/*
    (c) barsunduk
    06/2011
*/

import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Graphics;

public class Lib_vip
{
    private static int[] _bmp = null;
    private static int _bmpwidth = 0;
    private static int _bmpheight = 0;
    private static int _color = 0xff000000;
    private static int[] pix1 = new int[1];

    public static int getalpha(int col)
    {
        return (col >> 24) & 0xff;
    }

    public static int getred(int col)
    {
        return (col >> 16) & 0xff;
    }

    public static int getgreen(int col)
    {
        return (col >> 8) & 0xff;
    }

    public static int getblue(int col)
    {
        return col & 0xff;
    }

    public static int argb2int(int alpha, int red, int green, int blue)
    {
        alpha = (alpha < 0) ? 0 : (alpha & 0xff);
        red = (red < 0) ? 0 : (red & 0xff);
        green = (green < 0) ? 0 : (green & 0xff);
        blue = (blue < 0) ? 0 : (blue & 0xff);
        return (alpha << 24) | (red << 16) | (green << 8) | blue;
    }

    public static String scopy(String s, int offset, int count)
    {
        int l = s.length();
        count += (offset < 0) ? offset : 0;
        offset = (offset < 0) ? 0 : offset;
        count = (count < 0) ? 0 : count;
        count = (offset + count <= l) ? count : l - offset;
        s = ((offset < l) && (offset + count <= l)) ? s.substring(offset, offset + count) : "";
        return s;
    }

    public static String sdelete(String s, int offset, int count)
    {
        int l = s.length();
        return scopy(s, 0, offset) + scopy(s, offset + count, l - offset - count);
    }

    public static String trim(String s)
    {
        int l = s.length() - 1;
        int i0 = 0;
        int il = l;
        String res = "";
        if (s != "")
        {
            while ((s.charAt(i0) <= 0x20)&&(i0 <= il))
                i0++;
            while ((s.charAt(il) <= 0x20)&&(i0 <= il))
                il--;
            if ((i0 >= 0)&&(i0 <= il))
                res = s.substring(i0, il + 1);
        }
        return res;
    }

    public static String i2h(int i) {
        return Integer.toHexString(i);
    }

    public static int h2i(String s) {
        while (s.length() < 8) {
            s = "0" + s;
        }
        String hi = s.substring(0, 4);
        String lo = s.substring(4, s.length());
        return Integer.parseInt(lo, 16) | (Integer.parseInt(hi, 16) << 16);
    }

    public static void bmpcolorint(int col)
    {
        _color = col;
    }

    public static void bmpcolorhex(String col)
    {
        _color = h2i(col);
    }

    public static void setcolorint(int col)
    {
        M.G.setColor(col);
    }

    public static void setcolorhex(String col)
    {
        M.G.setColor(h2i(col));
    }

    private static boolean inrect(int x, int y)
    {
        return ((x >= 0)&&(y >= 0)&&(x < _bmpwidth)&&(y < _bmpheight));
    }

    public static void bmpfree()
    {
        _bmp = null;
        _bmpwidth = 0;
        _bmpheight = 0;
    }

    public static void bmpcreate(int w, int h)
    {
        bmpfree();
        if ((w > 0)&&(h > 0))
        {
            _bmp = new int[w * h];
            _bmpwidth = w;
            _bmpheight = h;
        }
    }

    public static void bmpsetscreen()
    {
        int w = M.I.getWidth();
        int h = M.I.getHeight();
        bmpcreate(w, h);
        M.I.getRGB(_bmp, 0, _bmpwidth, 0, 0, _bmpwidth, _bmpheight);
    }

    public static Image bmpgetimage()
    {
        return Image.createRGBImage(_bmp, _bmpwidth, _bmpheight, true);
    }

    public static void bmpsetimage(Image img)
    {
        int w = img.getWidth();
        int h = img.getHeight();
        if ((w | h) != 0)
        {
            bmpcreate(w, h);
            img.getRGB(_bmp, 0, _bmpwidth, 0, 0, _bmpwidth, _bmpheight);
        }
    }

    public static void bmpdraw(int x, int y)
    {
        M.G.drawRGB(_bmp, 0, _bmpwidth, x , y, _bmpwidth, _bmpheight, true);
    }

    public static void bmpdrawsolid(int x, int y)
    {
        M.G.drawRGB(_bmp, 0, _bmpwidth, x , y, _bmpwidth, _bmpheight, false);
    }

    public static int pixmix(int forecolor, int backcolor)
    {
        int a1 = (forecolor >> 24) & 0xff;
        int a2 = (backcolor >> 24) & 0xff;
        int r1 = (forecolor >> 16) & 0xff;
        int r2 = (backcolor >> 16) & 0xff;
        int g1 = (forecolor >> 8) & 0xff;
        int g2 = (backcolor >> 8) & 0xff;
        int b1 = forecolor & 0xff;
        int b2 = backcolor & 0xff;
        int a3 = 255 - a1;
        r1 = (r1 * a1 + r2 * a3) >> 8;
        g1 = (g1 * a1 + g2 * a3) >> 8;
        b1 = (b1 * a1 + b2 * a3) >> 8;
        return ((a2 | a1) << 24) | (r1 << 16) | (g1 << 8) | b1;
    }

    public static void bmpsetpixel(int x, int y, int col)
    {
        if ((x >= 0)&&(y >= 0)&&(x < _bmpwidth)&&(y < _bmpheight))
            _bmp[y * _bmpwidth + x] = col;
    }

    public static int bmpgetpixel(int x, int y)
    {
        int col = 0;
        if ((x >= 0)&&(y >= 0)&&(x < _bmpwidth)&&(y < _bmpheight))
            col = _bmp[y * _bmpwidth + x];
        return col;
    }

    public static void bmpplot(int x, int y, int col)
    {
        bmpsetpixel(x, y, pixmix(col, bmpgetpixel(x, y)));
    }

    public static int bmpwidth()
    {
        return _bmpwidth;
    }

    public static int bmpheight()
    {
        return _bmpheight;
    }

    public static void bmpline(int x1, int y1, int x2, int y2)
    {
        int dx = x2 - x1;
        int dy = y2 - y1;
        int l = (int) (Math.sqrt(dx*dx + dy*dy));
        l += 1;
        for(int i = 0; i <= l; i++)
            bmpsetpixel(x1 + i * dx / l, y1 + i * dy / l, _color);
    }

    public static void bmprect(int x, int y, int w, int h)
    {
        int x2 = x + w - 1;
        if (w < 0) x2 += 1;
        int y2 = y + h - 1;
        if (h < 0) y2 += 1;
        bmpline(x, y, x2, y);
        bmpline(x, y, x, y2);
        bmpline(x, y2, x2, y2);
        bmpline(x2, y, x2, y2);
    }

    public static void bmpfillrect(int x, int y, int w, int h)
    {
        if (w < 0)
        {
            x += w + 1;
            w = -w;
        }
        if (h < 0)
        {
            y += h + 1;
            h = -h;
        }
        if (x < 0)
        {
            w += x;
            x = 0;
        }
        if (y < 0)
        {
            h += y;
            y = 0;
        }
        if (x + w >= _bmpwidth)
        {
            w = _bmpwidth - x;
        }
        if (y + h >= _bmpheight)
        {
            h = _bmpheight - y;
        }
        if ((x < _bmpwidth)&&(y < _bmpheight))
        {
            int p = x + y * _bmpwidth;
            int pp = _bmpwidth - w;
            for (int iy = 1; iy <= h; iy++)
            {
                for (int ix = 1; ix <= w; ix++)
                {
                    _bmp[p] = _color;
                    p += 1;
                }
                p += pp;
            }
        }
    }

    private static int stp(int a, int b, int i)
    {
        int da = (b - a);
        return (a + ((i * da) >> 4));
    }

    public static void bmpbezier(int x1, int y1, int x2, int y2, int x3, int y3)
    {
        int lx = x1;
        int ly = y1;
        for(int i = 0; i <= 16; i++)
        {
            int x12 = stp(x1, x2, i);
            int y12 = stp(y1, y2, i);
            int x23 = stp(x2, x3, i);
            int y23 = stp(y2, y3, i);
            int x = stp(x12, x23, i);
            int y = stp(y12, y23, i);
            bmpline(lx, ly, x, y);
            lx = x;
            ly = y;
        }
    }

    public static void bmpbow(int x1, int y1, int x2, int y2, int x3, int y3)
    {
        bmpbezier(x1, y1, ((x2 << 2) - x1 - x3) >> 1, ((y2 << 2) - y1 - y3) >> 1, x3, y3);
    }

    public static void bmpellipse(int x, int y, int w, int h)
    {
        w -= 1;
        h -= 1;
        int x1 = x + (w >> 1);
        int y1 = y;
        int x2 = x + (w >> 1) - ((w * 942) >> 11);
        int y2 = y + (h >> 1) - ((h * 942) >> 11);
        int x3 = x;
        int y3 = y + (h >> 1);
        int lx = x1;
        int ly = y1;
        for(int i = 0; i <= 16; i++)
        {
            int x12 = stp(x1, x2, i);
            int y12 = stp(y1, y2, i);
            int x23 = stp(x2, x3, i);
            int y23 = stp(y2, y3, i);
            int xx = stp(x12, x23, i);
            int yy = stp(y12, y23, i);
            int l = (int) (Math.sqrt((xx - lx)*(xx - lx) + (yy - ly)*(yy - ly)));
            l += 1;
            for(int ii = 0; ii <= l; ii++)
            {
                int linex = lx + (ii * (xx - lx))/l;
                int liney = ly + (ii * (yy - ly))/l;
                int linex2 = x + x + w - linex;
                int liney2 = y + y + h - liney;
                bmpsetpixel(linex, liney,  _color);
                bmpsetpixel(linex, liney2, _color);
                bmpsetpixel(linex2, liney,  _color);
                bmpsetpixel(linex2, liney2, _color);
            }
            lx = xx;
            ly = yy;
        }
    }

    public static void bmpfillellipse(int x, int y, int w, int h)
    {
        w -= 1;
        h -= 1;
        int x1 = x + (w >> 1);
        int y1 = y;
        int x2 = x + (w >> 1) - ((w * 942) >> 11);
        int y2 = y + (h >> 1) - ((h * 942) >> 11);
        int x3 = x;
        int y3 = y + (h >> 1);
        int lx = x1;
        int ly = y1;
        for(int i = 0; i <= 16; i++)
        {
            int x12 = stp(x1, x2, i);
            int y12 = stp(y1, y2, i);
            int x23 = stp(x2, x3, i);
            int y23 = stp(y2, y3, i);
            int xx = stp(x12, x23, i);
            int yy = stp(y12, y23, i);
            int dx = xx - lx;
            int dy = yy - ly;
            int l = (int) (Math.sqrt(dx*dx + dy*dy));
            l += 1;
            for(int ii = 0; ii <= l; ii++)
            {
                int linex = lx + (ii * (xx - lx))/l;
                int liney = ly + (ii * (yy - ly))/l;
                int linex2 = x + x + w - linex;
                int liney2 = y + y + h - liney;
                for (int j = linex; j <= linex2; j++)
                {
                    bmpsetpixel(j, liney,  _color);
                    bmpsetpixel(j, liney2, _color);
                }
            }
            lx = xx;
            ly = yy;
        }
    }

    //   * 65535
    private static final int[] cos_table_180 =
    {
        65536, 65470, 65470, 65404, 65339, 65273, 65142, 65011, 64880, 64684,
        64487, 64290, 64094, 63832, 63569, 63242, 62980, 62652, 62324, 61931,
        61538, 61145, 60751, 60293, 59834, 59375, 58851, 58392, 57802, 57278,
        56754, 56164, 55574, 54919, 54329, 53673, 53018, 52297, 51642, 50921,
        50200, 49414, 48693, 47906, 47120, 46333, 45481, 44630, 43843, 42991,
        42074, 41222, 40304, 39387, 38469, 37552, 36634, 35651, 34668, 33751,
        32768, 31719, 30736, 29687, 28704, 27656, 26607, 25559, 24510, 23461,
        22413, 21299, 20250, 19136, 18022, 16908, 15794, 14680, 13565, 12451,
        11337, 10223, 9109, 7929, 6815, 5701, 4521, 3407, 2228, 1114, 0,
        -1114, -2228, -3407, -4521, -5701, -6815, -7929, -9109, -10223,
        -11337, -12451, -13565, -14680, -15794, -16908, -18022, -19136, -20250, -21299,
        -22413, -23461, -24510, -25559, -26607, -27656, -28704, -29687, -30736, -31719,
        -32702, -33751, -34668, -35651, -36634, -37552, -38469, -39387, -40304, -41222,
        -42074, -42991, -43843, -44630, -45481, -46333, -47120, -47906, -48693, -49414,
        -50200, -50921, -51642, -52297, -53018, -53673, -54329, -54919, -55574, -56164,
        -56754, -57278, -57802, -58392, -58851, -59375, -59834, -60293, -60751, -61145,
        -61538, -61931, -62324, -62652, -62980, -63242, -63569, -63832, -64094, -64290,
        -64487, -64684, -64880, -65011, -65142, -65273, -65339, -65404, -65470, -65470,
        -65536
    };

    //  ,     ..)
    public static int cos(int a) {
        int c = 0;
        a %= 360;
        a = (a < 0) ? 360 + a : a;
        if (a > 180) {
            c = -cos_table_180[a - 180];
        } else {
            c = cos_table_180[a];
        }
        return c;
    }

    //  
    // ...
    public static int sin(int a)
    {
        return cos(90 - a);
    }

    public static int abs(int a)
    {
        return (a < 0) ? -a : a;
    }

    public static void bmparc(int x, int y, int w, int h, int a1, int a2)
    {
        a1 = -a1;
        a2 = -a2;
        int w2 = w >> 1;
        int h2 = h >> 1;
        int x0 = x + w2;
        int y0 = y + h2;
        int aa1 = abs(a1);
        aa1 %= 360;
        if (a1 < 0) aa1 = 360 - aa1;
        int aa2 = abs(a2);
        aa2 %= 360;
        if (a2 < 0) aa2 = 360 - aa2;
        int lx = x0 + ((cos(aa1) * w2) >> 16);
        int ly = y0 + ((sin(aa1) * h2) >> 16);
        int i, ii, ii22, xx, yy;
        int bl = 360 - aa2 + aa1;
        bl = (bl < 0) ? 360 + bl : bl;
        for (i = 0; i <= bl; i++)
        {
            ii = abs(aa1);
            ii %= 360;
            if (aa1 < 0) ii = 360 - ii;
            xx = x0 + ((cos(ii) * w2) >> 16);
            yy = y0 + ((sin(ii) * h2) >> 16);
            if (xx >= x + w) xx = x + w - 1;
            if (yy >= y + h) yy = y + h - 1;
            bmpline(lx, ly, xx, yy);
            lx = xx;
            ly = yy;
            aa1--;
        }
    }

    public static void bmpfill(int x, int y)
    {
        if (inrect(x, y))
        {
            int col = bmpgetpixel(x, y);
            if (col != _color)
            {
                int[] stack = new int[_bmpwidth * _bmpheight];
                int stackpos = 0;
                stack[stackpos] = x | (y << 16);
                while (stackpos >= 0)
                {
                    int xy = stack[stackpos];
                    stackpos--;
                    x = xy & 0xffff;
                    y = xy >> 16;
                    _bmp[x + y * _bmpwidth] = _color;
                    int pp;
                    for (int ix = -1; ix <= 1; ix++)
                    for (int iy = -1; iy <= 1; iy++)
                    if (Math.abs(ix) != Math.abs(iy))
                    {
                        int x2 = x + ix;
                        int y2 = y + iy;
                        if (inrect(x2, y2))
                        {
                            pp = x2 + y2 * _bmpwidth;
                            if (_bmp[pp] == col)
                            {
                                stackpos++;
                                stack[stackpos] = x2 | (y2 << 16);
                            }
                        }
                    }
                }
                stack = null;
            }
        }
    }

    public static void bmprepcol(int col, int newcol)
    {
        int l = _bmpwidth * _bmpheight;
        if (l > 0)
        for (int i = 0; i < l; i++)
        if (_bmp[i] == col)
        _bmp[i] = newcol;
    }

    public static void bmpcls(int col)
    {
        int l = _bmpwidth * _bmpheight;
        if (l > 0)
        for (int i = 0; i < l; i++)
            _bmp[i] = col;
    }

    public static void bmptransp(int x, int y)
    {
        if (inrect(x, y))
        bmprepcol(bmpgetpixel(x, y), 0);
    }

    public static void bmpresize(int w, int h)
    {
        int[] pix = new int[w * h];
        for (int y = 0; y < h; y++)
        for (int x = 0; x < w; x++)
        {
            pix[y * w + x] = bmpgetpixel((x * _bmpwidth) / w, (y * _bmpheight) / h);
        }
        _bmpwidth = w;
        _bmpheight = h;
        _bmp = pix;
        pix = null;
    }

    public static String _coms = "new|plot|fill|line|rect|fillrect|bow|color|cls|ellipse|fillellipse|repcol|transp|arc";
    public static String _ton = "(";
    public static String _toff = ")";
    public static int _tdiv = 0x2C;
    private static String _code;
    private static int[] prms;
    private static int _comscnt = -1;
    private static int _codel = -1;
    private static int _com = -1;
    private static int _cpos;

    public static String strget(String s, int index)
    {
        int i = 0;
        int nowi = 0;
        int l = s.length();
        boolean loop = (index >= 0)&&(i < l);
        String res = "";
        while (loop)
        {
            char ch = s.charAt(i);
            if ((ch == 0x0D)||(ch == 0x7C))
            {
                nowi += 1;
            }
            else
            if (nowi == index)
            {
                res = res + ch;
            }
            if ((i == l - 1)||(nowi > index))
            {
                loop = false;
            }
            i += 1;
        }
        return res;
    }

    public static String strgetdiv(String s, int index, int divider)
    {
        int i = 0;
        int nowi = 0;
        int l = s.length();
        boolean loop = (index >= 0)&&(i < l);
        String res = "";
        while (loop)
        {
            char ch = s.charAt(i);
            if ((ch == 0x0D)||(ch == divider))
            {
                nowi += 1;
            }
            else
            if (nowi == index)
            {
                res = res + ch;
            }
            if ((i == l - 1)||(nowi > index))
            {
                loop = false;
            }
            i++;
        }
        return res;
    }

    public static int strcount(String s)
    {
        int l = s.length();
        int res = 0;
        char ch = 0x00;
        for(int i = 0; i < l; i++)
        {
            ch = s.charAt(i);
            if ((ch == 0x0D)||(ch == 0x7C))
            {
                res++;
            }
        }
        if ((ch != 0xDD)&&(ch != 0x7C)&&(l > 0))
        {
            res++;
        }
        return res;
    }

    public static int str2int(String s)
    {
        boolean hex = false;
        int res = -1;
            s = trim(s);
            if (s != "")
            try
            {
                if (s.charAt(0) == 0x24)
                {
                    s = sdelete(s, 0, 1);
                    hex = true;
                }
                if (hex)
                    res = h2i(s);
                else
                    res = Integer.parseInt(s, 10);
            }
            catch (NumberFormatException e)
            {
                        //
                    }
        return res;
    }

    private static boolean strhere(String str, int offset)
    {
        boolean res = false;
        int subl = str.length();
        String t = scopy(_code, offset, subl);
        if (str.equalsIgnoreCase(t))
            res = true;
        return res;
    }

    private static int comhere(int offset)
    {
        int res = -1;
        for (int i = 0; i < _comscnt; i++)
        {
            String command = strget(_coms, i);
            int subl = command.length();
            String t = scopy(_code, offset, subl);
            if (command.equalsIgnoreCase(t))
                res = i;
        }
        return res;
    }

    public static void vip2bmp(String code)
    {
        int comn = -1;
        _cpos = -1;
        _code = code;
        _codel = _code.length();
        _comscnt = strcount(_coms);
        boolean loop = (_codel > 0);
        bmpcreate(M.I.getWidth(), M.I.getHeight());
        String pp = "";
        prms = null;
        prms = new int[8];
        while (loop)
        {
            comn = comhere(_cpos);
            while ((comn < 0)&&(_cpos < _codel))
            {
                _cpos++;
                comn = comhere(_cpos);
            }
            if (comn >= 0)
            {
                while ((_cpos < _codel)&&(! strhere(_ton, _cpos)))
                    _cpos++;
                _cpos += _ton.length();
                int i0 = _cpos;
                while ((_cpos < _codel)&&(! strhere(_toff, _cpos)))
                    _cpos++;
                int il = _cpos;
                _cpos += _toff.length();
                pp = scopy(_code, i0, il - i0);
                for (int i = 0; i < 8; i++)
                    prms[i] = str2int(strgetdiv(pp, i, _tdiv));
                if (comn == 0)
                    bmpcreate(prms[0], prms[1]);
                if (comn == 1)
                    bmpsetpixel(prms[0], prms[1], _color);
                if (comn == 2)
                    bmpfill(prms[0], prms[1]);
                if (comn == 3)
                    bmpline(prms[0], prms[1], prms[2], prms[3]);
                if (comn == 4)
                    bmprect(prms[0], prms[1], prms[2], prms[3]);
                if (comn == 5)
                    bmpfillrect(prms[0], prms[1], prms[2], prms[3]);
                if (comn == 6)
                    bmpbow(prms[0], prms[1], prms[2], prms[3], prms[4], prms[5]);
                if (comn == 7)
                    _color = prms[0];
                if (comn == 8)
                    bmpcls(prms[0]);
                if (comn == 9)
                    bmpellipse(prms[0], prms[1], prms[2], prms[3]);
                if (comn == 10)
                    bmpfillellipse(prms[0], prms[1], prms[2], prms[3]);
                if (comn == 11)
                    bmprepcol(prms[0], prms[1]);
                if (comn == 12)
                    bmptransp(prms[0], prms[1]);
                if (comn == 13)
                    bmparc(prms[0], prms[1], prms[2], prms[3], prms[4], prms[5]);
            }
            if (_cpos >= _codel - 1)
                loop = false;
        }
    }

    public static Image vip2image(String code)
    {
        vip2bmp(code);
        Image img = bmpgetimage();
        bmpfree();
        return img;
    }

    public static void drawvip(String code, int x, int y)
    {
        vip2bmp(code);
        bmpdraw(x, y);
        bmpfree();
    }

}